define([
    'jquery',
    'underscore'
], function ($, _) {
    'use strict';

    function initItemsGa4(action, products, currency, isDisabledUaDatalayer) {
        if (!isDisabledUaDatalayer && _.isArray(products.GA4)) {
            dataLayer.push({
                'event': 'view_item_list',
                'ecommerce': {
                    'currency': currency,
                    [action]: products.GA4
                }
            });
        }
    }

    function initImpressionsUa(action, products, currency,) {
        if (_.isArray(products.UA)) {
            dataLayer.push({
                'event':'productList',
                'ecommerce': {
                    'currencyCode': currency,
                    [action]: products.UA
                }
            });
        }
    }

    /**
     * @param {Object} config
     */
    return function (config) {
        if (
            _.has(config, 'impressions')
            && _.isObject(config.impressions)
            && _.isArray(config.impressions.GA4)
            && config.impressions.GA4.length > 0
        ) {
            initItemsGa4('items', config.impressions, config.currency);
            if (!config.isDisabledUaDatalayer && config.impressions.UA.length > 0) {
                initImpressionsUa('impressions', config.impressions, config.currency);
            }
        }
    }
});
